ClarisWksTableInternal::Table Struct Reference documentation

Public Member Functions | Public Attributes | Private Member Functions | Friends | List of all members
ClarisWksTableInternal::Table Struct Referencefinal

the struct which stores the Table More...

Inheritance diagram for ClarisWksTableInternal::Table:

## Public Member Functions
| Table (ClarisWksStruct::DSET const &dset, ClarisWksTable &parser, ClarisWksStyleManager &styleManager)
| constructor
| ~Table () final
| destructor
TableCell * | get (int id)
| return a cell corresponding to id
void | removeChild (int cId, bool normalChild) final
| remove a child from a list.
void | updateCells ()
| finish updating all cells
bool | askMainToSendZone (int number)
| ask the main parser to send a zone
Public Member Functions inherited from ClarisWksStruct::DSET
| DSET ()
| constructor
| DSET (DSET const &)=default
virtual | ~DSET ()
| virtual destructor
bool | isHeaderFooter () const
| test if the zone is an header/footer
bool | isSlide () const
| test if the zone is a slide
MWAWBox2f | getBdBox () const
| return the zone bdbox
int | getMaximumPage () const
| returns the maximum page
virtual void | removeChild (int cId, bool normalChild)
| virtual function to remove a child from a list
virtual void | removeChild (int cId)
| virtual function to remove a child from a list
void | updateChildPositions (MWAWVec2f const &pageDim, float formLength, int numHorizontalPages=1)
| try to update the child page and bounding box
void | findForbiddenPagesBreaking (float pageDim, float formDim, int dim, MWAWVariable< int > &lastPage) const
| find forbidden page break
MWAWBox2i | getUnionChildBox () const
| returns the child box (ie. the union of the childs box)
Public Member Functions inherited from MWAWTable
| MWAWTable (uint32_t givenData=BoxBit)
| the constructor
virtual | ~MWAWTable ()
| the destructor
void | add (std::shared_ptr< MWAWCell > cell)
| add a new cells
bool | mergeBorders () const
| returns true if we need to merge borders
bool | setMergeBorders (bool val)
| sets the merge borders' value
void | setAlignment (Alignment align, float leftMargin=0, float rightMargin=0)
| defines the current alignment
int | numCells () const
| returns the number of cell
std::vector< float > const & | getRowsSize () const
| returns the row size if defined (in point)
void | setRowsSize (std::vector< float > const &rSize)
| define the row size (in point)
std::vector< float > const & | getColsSize () const
| returns the columns size if defined (in point)
void | setColsSize (std::vector< float > const &cSize)
| define the columns size (in point)
std::shared_ptr< MWAWCell > | get (int id)
| returns the i^th cell
bool | updateTable ()
| try to build the table structures
bool | hasExtraLines ()
| returns true if the table has extralines
bool | sendTable (MWAWListenerPtr listener, bool inFrame=true)
| try to send the table
bool | sendAsText (MWAWListenerPtr listener)
| try to send the table as basic text
void | addTablePropertiesTo (librevenge::RVNGPropertyList &propList) const
| adds the table properties to propList

## Public Attributes
ClarisWksTable * | m_parser
| the main parser
ClarisWksStyleManager * | m_styleManager
| the style manager
std::vector< Border > | m_bordersList
| the list of border
long | m_mainPtr
| the relative main pointer
bool | m_auxiliaryDetached
| true if the auxiliary zone is detached
Public Attributes inherited from ClarisWksStruct::DSET
long | m_size
| the size of the DSET header
long | m_numData
| the number of header
long | m_dataSz
| the data size
long | m_headerSz
| the header size
Position | m_position
| the zone type
int | m_fileType
| the type ( 0: text, -1: graphic, ...)
int | m_page
| the page (if known)
MWAWBox2f | m_box
| the bounding box (if known)
MWAWVec2f | m_pageDimension
| the page dimension (if know)
int | m_id
| the zone identificator
std::set< int > | m_fathersList
| the list of fathers
int | m_beginSelection
| the begin of selection ( at least in text header)
int | m_endSelection
| the end of selection ( at least in text header)
int | m_textType
| the text type (header/footer,footnote, ...)
int | m_flags [4]
| some unknown flag
std::vector< Child > | m_childs
| the list of child zone
std::vector< int > | m_otherChilds
| the list of other child
bool | m_parsed
| a flag to know if the entry is sent or not to the listener
int | m_internal
| an internal variable used to do some computation

## Private Member Functions
| Table (Table const &orig)=delete
Table & | operator= (Table const &orig)=delete

## Friends
struct | TableCell
std::ostream & | operator<< (std::ostream &o, Table const &doc)
| operator<<

## Additional Inherited Members
Public Types inherited from ClarisWksStruct::DSET
enum | Position { P_Main =0 , P_Header , P_Footer , P_Frame , P_Footnote , P_Table , P_GraphicMaster , P_Slide , P_SlideNote , P_SlideThumbnail , P_SlideMaster , P_Unknown }
| the zone position More...
enum | ChildType { C_Zone , C_SubText , C_Graphic , C_Unknown }
| the different types of zone child More...
Public Types inherited from MWAWTable
enum | DataSet { CellPositionBit =1 , BoxBit =2 , SizeBit =4 , TableDimBit =8 , TablePosToCellBit =0x10 }
| an enum used to indicate what the list of entries which are filled More...
enum | Alignment { Paragraph , Left , Center , Right }
| an enum do define the table alignment. More...
Protected Member Functions inherited from MWAWTable
int | getCellIdPos (int col, int row) const
| convert a cell position in a posToCellId's position
bool | buildStructures ()
| create the correspondance list, ...
bool | buildDims ()
| compute the rows and the cells size
bool | buildPosToCellId ()
| a function which fills to posToCellId vector using the cell position
void | sendExtraLines (MWAWListenerPtr listener) const
| send extra line
Protected Attributes inherited from MWAWTable
uint32_t | m_givenData
| a int to indicate what data are given in entries
uint32_t | m_setData
| a int to indicate what data are been reconstruct
bool | m_mergeBorders
| do we need to merge cell borders ( default yes)
std::vector< std::shared_ptr< MWAWCell > > | m_cellsList
| the list of cells
size_t | m_numRows
| the number of rows ( set by buildPosToCellId )
size_t | m_numCols
| the number of cols ( set by buildPosToCellId )
std::vector< float > | m_rowsSize
| the final row size (in point)
std::vector< float > | m_colsSize
| the final col size (in point)
Alignment | m_alignment
| the table alignment
float | m_leftMargin
| the left margin in point
float | m_rightMargin
| the right margin in point
std::vector< int > | m_posToCellId
| a vector used to store an id corresponding to each cell
bool | m_hasExtraLines
| true if we need to send extra lines

## Detailed Description

the struct which stores the Table

## Constructor & Destructor Documentation

## ◆ Table() [1/2]

ClarisWksTableInternal::Table::Table | ( | ClarisWksStruct::DSET const & | dset,
|  | ClarisWksTable & | parser,
|  | ClarisWksStyleManager & | styleManager
| ) |  |
| inline

constructor

## ◆ ~Table()

ClarisWksTableInternal::Table::~Table | ( |  | ) |
| final

destructor

## ◆ Table() [2/2]

ClarisWksTableInternal::Table::Table | ( | Table const & | orig | ) |
| privatedelete

## Member Function Documentation

## ◆ askMainToSendZone()

bool ClarisWksTableInternal::Table::askMainToSendZone | ( | int | number | ) |
| inline

ask the main parser to send a zone

## ◆ get()

TableCell * ClarisWksTableInternal::Table::get | ( | int | id | ) |
| inline

return a cell corresponding to id

Referenced by ClarisWksTable::readTableBordersId(), and updateCells().

## ◆ operator=()

Table & ClarisWksTableInternal::Table::operator= | ( | Table const & | orig | ) |
| privatedelete

## ◆ removeChild()

void ClarisWksTableInternal::Table::removeChild | ( | int | cId,
|  | bool | normalChild
| ) |  |
| inlinefinalvirtual

remove a child from a list.

Normally, this function is not called, so optimizing it is not usefull

Reimplemented from ClarisWksStruct::DSET.

## ◆ updateCells()

void ClarisWksTableInternal::Table::updateCells | ( |  | ) |
| inline

finish updating all cells

## Friends And Related Function Documentation

## ◆ operator<<

std::ostream & operator<< | ( | std::ostream & | o,
|  | Table const & | doc
| ) |  |
| friend

operator<<

## ◆ TableCell

friend struct TableCell
| friend

## Member Data Documentation

## ◆ m_auxiliaryDetached

bool ClarisWksTableInternal::Table::m_auxiliaryDetached

true if the auxiliary zone is detached

Referenced by removeChild().

## ◆ m_bordersList

std::vector<Border> ClarisWksTableInternal::Table::m_bordersList

the list of border

Referenced by ClarisWksTable::readTableBorders(), ClarisWksTable::readTableBordersId(), and ClarisWksTableInternal::TableCell::update().

## ◆ m_mainPtr

long ClarisWksTableInternal::Table::m_mainPtr

the relative main pointer

Referenced by ClarisWksTable::readTablePointers().

## ◆ m_parser

ClarisWksTable* ClarisWksTableInternal::Table::m_parser

the main parser

Referenced by askMainToSendZone().

## ◆ m_styleManager

ClarisWksStyleManager* ClarisWksTableInternal::Table::m_styleManager

the style manager

Referenced by ClarisWksTableInternal::TableCell::update().

The documentation for this struct was generated from the following file:

- ClarisWksTable.cxx